
/*
	cdev Shell  --  Version 0.90  --  May 14, 1991
	
	Copyright (c) 1990,91 by Neal E. Trautman
	
	'ShareWare' -- Please send $5 contribution to:

		Neal Trautman
		3700 Clinton Parkway, #1412
		Lawrence, KS  66047
	
	This is a Control Panel cdev Shell.
*/


enum {
	cursorDev = 14
};

#define	NULL			0L

typedef struct cdevStorageRec {
	TEHandle	myTE;
} cdevStorageRec, *cdevStorageRecPtr, **cdevStorageRecHnd;
	

static void DoHit (item,numitems,CPDialog,cdevStorage)
	int			item,numitems;
	DialogPtr	CPDialog;
	Handle		cdevStorage;
{
}

static void DoEdit (message,CPDialog)
	int			message;
	DialogPtr	CPDialog;
{
	switch (message)
		{
		case cutDev:
			DlgCut(CPDialog);
			break;
		case copyDev:
			DlgCopy(CPDialog);
			break;
		case pasteDev:
			DlgPaste(CPDialog);
			break;
		case clearDev:
			DlgDelete(CPDialog);
			break;
		}
}

pascal long main (
			int message,
			int item,
			int numItems,
			int CPanelID,
			EventRecord *theEvent,
			Handle cdevStorage,
			DialogPtr CPDialog
	);
pascal long main (message,item,numitems,CPanelID,theEvent,cdevStorage,CPDialog)
	int			message,item,numitems,CPanelID;
	EventRecord	*theEvent;
	Handle		cdevStorage;
	DialogPtr	CPDialog;
{
	if ((cdevStorage != NULL) && ((long)cdevStorage != 1L) && ((long)cdevStorage != -1L))
		{
		switch (message)
			{
			case initDev:
				{
				cdevStorage = NewHandle(sizeof(cdevStorageRec));
				if (cdevStorage != NULL)
					{
					DoHit(item,numitems,CPDialog,cdevStorage);
					}
				break;
				}
			case hitDev:
				{
				DoHit(item,numitems,CPDialog,cdevStorage);
				break;
				}
			case closeDev:
				{
				if (cdevStorage != NULL)
					DisposHandle(cdevStorage);
				cdevStorage = NULL;
				break;
				}
			case nulDev:
			case updateDev:
			case activDev:
			case deactivDev:
			case cursorDev:
				{
				break;
				}
			case keyEvtDev:
				{
				if (theEvent->modifiers & cmdKey)
					{
					message = nulDev;
					switch (theEvent->message & charCodeMask)
						{
						case 'z':
						case 'Z':
							message = undoDev;
							break;
						case 'x':
						case 'X':
							message = cutDev;
							break;
						case 'c':
						case 'C':
							message = copyDev;
							break;
						case 'v':
						case 'V':
							message = pasteDev;
							break;
						}
					if (message != nulDev)
						DoEdit (message,CPDialog);
					}
				break;
				}
			case macDev:
				{
				return (true);
				break;
				}
			case undoDev:
			case cutDev:
			case copyDev:
			case pasteDev:
			case clearDev:
				{
				DoEdit (message,CPDialog);
				break;
				}
			}
		}
	return((long)cdevStorage);
}
